package com.sf.service.gateway.domain.dto;

import com.sf.service.gateway.domain.GatewayInterfaceInfo;
import com.sf.service.gateway.domain.GatewayInterfaceMock;
import com.sf.vertx.api.pojo.MockMatchCondition;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

import static org.apache.commons.lang3.StringUtils.EMPTY;

/**
* 网关服务-接口Mock配置表
* @TableName Gateway_interface_mock
*/
@Data
public class InsertGatewayInterfaceMockDTO {

    /**
    * ID
    */
    @ApiModelProperty("ID")
    private Long id;
    /**
    * 接口id
    */
    @ApiModelProperty("接口id")
    private Long interfaceId;
    /**
    * http状态码
    */
    @ApiModelProperty("http状态码")
    private Integer httpStatus;
    /**
    * 匹配条件
    */
    @ApiModelProperty("匹配条件")
    private List<MockMatchCondition> matchConditions;
    /**
    * Mock响应，JSON字符串
    */
    @ApiModelProperty("Mock响应，JSON字符串")
    private String mockResponse;
    /**
    * 状态（0停用 1启用）
    */
    @ApiModelProperty("状态（0停用 1启用）")
    private String status;
    /**
    * 排序
    */
    @ApiModelProperty("排序")
    private Integer orderNum;


}
