package com.sf.vertx.enums;

/**
 * 支持的请求方法
 *
 * @author zoukun
 */
public enum RequestMethod
{
    GET("GET", "GET"),
    POST("POST", "POST"),
    PUT("PUT", "PUT"),
    DELETE("DELETE", "DELETE"),
    HEAD("HEAD", "HEAD"),
    ;

    private final String code;
    private final String info;

    RequestMethod(String code, String info)
    {
        this.code = code;
        this.info = info;
    }

    public String getCode()
    {
        return code;
    }

    public String getInfo()
    {
        return info;
    }

    public static RequestMethod getByCode(String code){
        for (RequestMethod value : RequestMethod.values()) {
            if (value.code.equalsIgnoreCase(code)){
                return value;
            }
        }
        return null;
    }
}
